/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const Ht=require("react"),k=require("prop-types"),o=require("@progress/kendo-react-common"),Wt=require("@progress/kendo-react-labels"),nt=require("@progress/kendo-svg-icons"),_t=require("../common/ListContainer.js"),Ut=require("../common/ListFilter.js"),rt=require("../common/GroupStickyHeader.js"),Gt=require("../common/ListDefaultItem.js"),jt=require("../common/List.js"),at=require("../common/DropDownBase.js"),u=require("../common/utils.js"),Yt=require("../package-metadata.js"),ot=require("@progress/kendo-react-buttons"),$t=require("@progress/kendo-react-intl"),Fe=require("../messages/index.js"),Me=require("@progress/kendo-react-layout");function Jt(v){const Y=Object.create(null,{[Symbol.toStringTag]:{value:"Module"}});if(v){for(const T in v)if(T!=="default"){const N=Object.getOwnPropertyDescriptor(v,T);Object.defineProperty(Y,T,N.get?N:{enumerable:!0,get:()=>v[T]})}}return Y.default=v,Object.freeze(Y)}const s=Jt(Ht),Qt="Please select a value from the list!",pe=s.forwardRef((v,Y)=>{let T=!1;if(v.filterable||v.virtual){const e=[];v.filterable&&e.push("filterable"),v.virtual&&e.push("virtualization"),T=!o.validatePackage(Yt.packageMetadata,{component:"DropDownList",features:e})}const N=o.useUnstyled(),me=o.useId(v.id),r=o.usePropsContext(st,v),{delay:it=F.delay,tabIndex:lt=F.tabIndex,ignoreCase:fe=F.ignoreCase,size:$=F.size,rounded:Te=F.rounded,fillMode:ge=F.fillMode,groupMode:Xt=F.groupMode}=r,ve=()=>{var e;if(o.canUseDOM)return((e=Q.current)==null?void 0:e.ownerDocument)||window.document},ct=()=>{var e,n;(e=t==null?void 0:t.current)!=null&&e.wrapper&&((n=t==null?void 0:t.current)==null||n.wrapper.focus({preventScroll:!0}))},E=()=>{let e;return q.current!==void 0&&q.current!==null?e=q.current:r.value!==void 0?e=r.value:f.value!==void 0&&f.value!==null?e=f.value:r.defaultValue!==void 0&&r.defaultValue!==null&&(e=r.defaultValue),!u.isPresent(e)&&r.defaultItem!==void 0&&r.defaultItem!==null&&(e=r.defaultItem),e},dt=()=>{const{dataItemKey:e}=r,n=u.getFilteredData(v),i=E();return n.findIndex(p=>u.areSame(p,i,e))},De=()=>r.required!==void 0?r.required:F.required,ye=()=>{const e=r.validationMessage!==void 0,n=E(),i=!De()||n!==null&&n!==""&&n!==void 0,p=r.valid!==void 0?r.valid:i;return{customError:e,valid:p,valueMissing:n===null}},ut=()=>r.validityStyles!==void 0?r.validityStyles:F.validityStyles,ne=e=>{re.current=!0,e.focus(),window.setTimeout(()=>re.current=!1,30)},he=()=>{X.current&&ne(X.current),r.adaptive&&setTimeout(()=>{X.current&&ne(X.current)},300)},pt=s.useCallback(e=>{for(const n of e)Kt(n.target.clientWidth)},[]),Oe=()=>{var e;(e=xe.current)!=null&&e.setCustomValidity&&xe.current.setCustomValidity(ye().valid?"":r.validationMessage||Qt)},H=(e,n)=>{const i=E();u.areSame(i,e,r.dataItemKey)||(r.value===void 0&&(n.data.value=e),t.current.updateComponentArgs({value:e}),q.current=e,n.events.push({type:"onChange"}))},K=e=>{var n;(n=t==null?void 0:t.current)==null||n.applyState(e),q.current=void 0},J=(e,n)=>{var c;const{virtual:i,dataItemKey:p,defaultItem:m}=r,g=u.getFilteredData(v),y=i?i.skip:0,D=E(),a=e===-1&&m!==void 0?m:g[e-y],d=!u.areSame(a,D,p);H(a,n),d&&((c=t==null?void 0:t.current)==null||c.triggerPageChangeCornerItems(a,n))},O=(e,n,i)=>{var I,w;const{defaultItem:p,dataItemKey:m,virtual:g={skip:0,total:0,pageSize:0}}=r,y=E(),D=u.getFilteredData(v),a=(I=t==null?void 0:t.current)==null?void 0:I.vs,d=D.findIndex(S=>u.areSame(S,y,m)),c=(w=t==null?void 0:t.current)==null?void 0:w.navigation.navigate({current:g.skip+d,max:(a!=null&&a.enabled?g.total:D.length)-1,min:p!==void 0?-1:0,keyCode:n,skipItems:i||void 0});c!==void 0&&J(c,e),K(e)},mt=e=>{Q.current=e,t.current.wrapper=e},ft=e=>s.createElement("select",{name:r.name,ref:n=>{xe.current=n},tabIndex:-1,"aria-hidden":!0,title:r.label,style:{opacity:0,width:1,border:0,zIndex:-1,position:"absolute",left:"50%"}},s.createElement("option",{value:r.valueMap?r.valueMap.call(void 0,e):e})),we=()=>{const{textField:e,dataItemKey:n,virtual:i={skip:0},focusedItemIndex:p=u.itemIndexStartsWith,filterable:m,skipDisabledItems:g=!0}=r,y=E(),D=u.getFilteredData(v),a=r.filter?r.filter:f.text;return g&&e&&!a&&!y?D.findIndex(d=>!d.disabled&&d[e]):u.isPresent(y)&&a===void 0||m&&a===""?D.findIndex(d=>u.areSame(d,y,n)):a?Ce.current?p(D,a,e):D.findIndex(d=>u.areSame(d,y,n)):i.skip===0?0:-1},qe=(e,n)=>n!==void 0&&n!==-1&&e&&e.length>0&&e[n].disabled,Ie=()=>{const e=u.getFilteredData(v),n=t.current.initState(),i=we();qe(e,i)&&(H(null,n),K(n))},Se=e=>{if(e.isPropagationStopped())return;const n=t.current.initState();n.syntheticEvent=e,f.focused||(n.data.focused=!0),Ie(),t.current.togglePopup(n),K(n)},Ae=e=>{var M,de,B,ue,j,et,tt;e&&e.target instanceof Element&&e.target.nodeName==="INPUT"&&e.stopPropagation&&e.stopPropagation();const{filterable:n,disabled:i,defaultItem:p,leftRightKeysNavigation:m=!0,virtual:g={skip:0,total:0,pageSize:0},dataItemKey:y,groupField:D="",textField:a,skipDisabledItems:d=!0}=r,c=u.getFilteredData(v),I=E(),w=c.findIndex(L=>u.areSame(L,I,y)),S=r.opened!==void 0?r.opened:f.opened,l=e.keyCode,P=l===o.Keys.home||l===o.Keys.end,b=l===o.Keys.up||l===o.Keys.down,G=!S&&(e.altKey&&l===o.Keys.down||l===o.Keys.enter||l===o.Keys.space),te=S&&(e.altKey&&l===o.Keys.up||l===o.Keys.esc),le=m&&(l===o.Keys.left||l===o.Keys.right),ce=b||le&&!n||P,C=t.current.initState();if(C.syntheticEvent=e,!i){if(P&&((M=t==null?void 0:t.current)!=null&&M.vs.enabled))l===o.Keys.home?g.skip!==0?((de=t==null?void 0:t.current)==null||de.triggerOnPageChange(C,0,g.pageSize),A.current=!0):H(c[0],C):g.skip<g.total-g.pageSize?((B=t==null?void 0:t.current)==null||B.triggerOnPageChange(C,g.total-g.pageSize,g.pageSize),A.current=!0):H(c[c.length-1],C);else if(S&&l===o.Keys.pageUp)e.preventDefault(),(ue=t==null?void 0:t.current)==null||ue.scrollPopupByPageSize(-1);else if(S&&l===o.Keys.pageDown)e.preventDefault(),(j=t==null?void 0:t.current)==null||j.scrollPopupByPageSize(1);else if(S&&l===o.Keys.enter){const L=we();qe(c,L)?(H(null,C),K(C)):J(L,C),(et=t==null?void 0:t.current)==null||et.togglePopup(C),e.preventDefault()}else if(G||te)te&&Ie(),(tt=t==null?void 0:t.current)==null||tt.togglePopup(C),e.preventDefault();else if(ce){if(Ce.current=!1,D!==""&&a)if(!d&&S)O(C,l);else{let L;if(l===o.Keys.down||l===o.Keys.right){const x=c.slice(w+1).find(h=>!h.disabled&&h[a]);L=x&&c.findIndex(h=>h[a]===x[a])}else if(l===o.Keys.up||l===o.Keys.left){let x;if(w===0&&p)L=-1;else if(w===-1)x=c,L=c.findIndex(h=>!h.disabled&&h[a]);else{x=c.slice(0,w);let h=x.pop();for(;h&&h.disabled;)h=x.pop();L=h&&c.findIndex(Pe=>Pe[a]===h[a])}}if(L!==void 0){const x=L-w;O(C,l,x)}else L===void 0&&c.findIndex(x=>x[a]===I[a])===c.length-1&&O(C,l)}else if(!d&&S||P)O(C,l);else if(a){let L;if(l===o.Keys.down||l===o.Keys.right){const x=c.slice(w+1).find(h=>!h.disabled&&h[a]);L=x&&c.findIndex(h=>h[a]===x[a])}else if(l===o.Keys.up||l===o.Keys.left){let x;if(w===0&&p)L=-1;else if(w===-1)x=c,L=c.find(h=>!h.disabled&&h[a]);else{x=c.slice(0,w);let h=x.pop();for(;h&&h.disabled;)h=x.pop();L=h&&c.findIndex(Pe=>Pe[a]===h[a])}}if(L!==void 0){const x=L-w;O(C,l,x)}else L===void 0&&c.findIndex(x=>x[a]===I[a])===c.length-1&&O(C,l)}else O(C,l);e.preventDefault()}K(C)}},gt=e=>{const n=t.current.initState();n.syntheticEvent=e.syntheticEvent,r.filter===void 0&&(n.data.text=e.target.value),t.current.filterChanged(e.target.value,n),Ce.current=!0,K(n),R({group:void 0,text:String(e.target.value)})},ze=()=>{const e=r.filter!==void 0?r.filter:f.text;return r.filterable&&s.createElement(Ut,{value:e,ref:n=>X.current=n&&n.element,onChange:gt,onKeyDown:Ae,size:$,rounded:Te,fillMode:ge,renderListFilterWrapper:!0})},vt=e=>{var i;const n=t.current.initState();n.syntheticEvent=e,(i=t==null?void 0:t.current)==null||i.togglePopup(n),H(r.defaultItem,n),K(n)},Ve=()=>{const{textField:e,defaultItem:n,dataItemKey:i}=r,p=E();return n!==void 0&&s.createElement(Gt,{defaultItem:n,textField:e,selected:u.areSame(p,n,i),key:"defaultitemkey",onClick:vt})},Dt=(e,n)=>{var i;(i=t==null?void 0:t.current)==null||i.handleItemClick(e,n),q.current=void 0},yt=e=>{const{vs:n,list:i}=t.current;n.scrollHandler(e);const{groupField:p}=r;let m=u.getFilteredData(v);if(!(!p||!m.length)&&p){const g=_e.current=_e.current||(n.enabled?n.itemHeight:i?i.children[0].offsetHeight:0),D=e.target.scrollTop-n.skip*g;m=t.current.getGroupedDataModernMode(m,p);let a=m[0][p];for(let d=1;d<m.length&&!(g*d>D);d++)m[d]&&m[d][p]&&(a=m[d][p]);a!==f.group&&R({group:a})}},Be=()=>{var l;const{textField:e,dataItemKey:n,virtual:i={skip:0,total:void 0},groupHeaderItemRender:p,listNoDataRender:m,itemRender:g}=r,y=u.getFilteredData(v),D=N&&N.uDropDownList,a=t.current.vs,d=i.skip,c=r.opened!==void 0?r.opened:f.opened,I=t.current.getPopupSettings(),w=`translateY(${a.translate}px)`,S=E();return s.createElement(jt,{id:ke,show:c,data:y.slice(),focusedIndex:we(),value:S,textField:e,valueField:n,optionsGuid:je,groupField:r.groupField,groupMode:"modern",listRef:P=>a.list=t.current.list=P,wrapperStyle:{maxHeight:I.height},wrapperCssClass:o.classNames(o.uDropDownList.listContent({c:D})),listStyle:a.enabled?{transform:w}:void 0,key:"listkey",skip:d,onClick:Dt,itemRender:g,groupHeaderItemRender:p,noDataRender:m,onScroll:yt,wrapperRef:a.scrollerRef,scroller:(l=t==null?void 0:t.current)==null?void 0:l.renderScrollElement(),ariaSetSize:i.total})},ht=()=>{var w;const{header:e,footer:n,adaptiveTitle:i,groupField:p,groupStickyHeaderItemRender:m,list:g}=r,y=u.getFilteredData(v),D=r.opened!==void 0?r.opened:f.opened,a=N&&N.uDropDownList,d=N&&N.uDropDownsActionSheet,c={navigatable:!1,navigatableElements:[],expand:D,animation:!0,onClose:S=>Se(S),className:o.classNames(o.uDropDownsActionSheet.wrapper({c:d}),"k-adaptive-actionsheet"),animationStyles:_&&U&&_<=U.small?{top:0,width:"100%",height:"100%"}:void 0,position:_&&U&&_<=U.small?"fullscreen":void 0};let{group:I}=f;return I===void 0&&p!==void 0&&(I=u.getItemValue(y[0],p)),s.createElement(Me.ActionSheet,{...c},s.createElement(Me.ActionSheetHeader,{className:o.classNames(o.uDropDownsActionSheet.header({c:d}))},s.createElement("div",{className:o.classNames(o.uDropDownsActionSheet.titleBar({c:d}))},s.createElement("div",{className:o.classNames(o.uDropDownsActionSheet.title({c:d}))},s.createElement("div",null,i)),s.createElement("div",{className:o.classNames(o.uDropDownsActionSheet.actions({c:d}))},s.createElement(ot.Button,{tabIndex:0,"aria-label":"Cancel","aria-disabled":"false",type:"button",fillMode:"flat",onClick:Se,icon:"x",svgIcon:nt.xIcon}))),s.createElement("div",{className:o.classNames(o.uDropDownsActionSheet.titleBarGroup({c:d}))},ze())),s.createElement(Me.ActionSheetContent,{overflowHidden:!0},e&&s.createElement("div",{className:o.classNames(o.uDropDownList.listHeader({c:a}))},e),s.createElement("div",{className:o.classNames(o.uDropDownList.list({c:a,size:$,virtual:(w=t==null?void 0:t.current)==null?void 0:w.vs.enabled}))},Ve(),!g&&I&&y.length!==0&&s.createElement(rt,{group:I,groupMode:"modern",render:m}),Be()),n&&s.createElement("div",{className:o.classNames(o.uDropDownList.listFooter({c:a}))},n)))},wt=()=>{f.focused&&window.setTimeout(()=>{f.focused&&t.current.wrapper&&ne(t.current.wrapper)})},It=e=>{var n;(n=r.popupSettings)!=null&&n.onMouseDownOutside&&r.popupSettings.onMouseDownOutside.call(void 0,e)},St=()=>{const{header:e,footer:n,dir:i,groupField:p,groupStickyHeaderItemRender:m,list:g}=r,y=u.getFilteredData(v),D=t.current,a=D.getPopupSettings(),d=r.opened!==void 0?r.opened:f.opened,c=a.width!==void 0?a.width:D.popupWidth,I=N&&N.uDropDownList,w={dir:i!==void 0?i:D.dirCalculated,width:c,popupSettings:{...a,popupClass:o.classNames(a.popupClass,o.uDropDownList.listContainer({c:I})),anchor:a.anchor||Q.current,show:d,onOpen:he,onClose:wt,onMouseDownOutside:It},itemsCount:[y.length]};let{group:S}=f;return S===void 0&&p!==void 0&&(S=u.getItemValue(y[0],p)),s.createElement(_t,{...w},ze(),e&&s.createElement("div",{className:o.classNames(o.uDropDownList.listHeader({c:I}))},e),s.createElement("div",{className:o.classNames(o.uDropDownList.list({c:I,size:$,virtual:t.current.vs.enabled}))},Ve(),!g&&S&&y.length!==0&&s.createElement(rt,{group:S,groupMode:"modern",render:m}),Be()),n&&s.createElement("div",{className:o.classNames(o.uDropDownList.listFooter({c:I}))},n),T&&s.createElement(o.WatermarkOverlay,null))},xt=e=>{const{dataItemKey:n}=r,i=u.getFilteredData(v),p=E();let m=i.map((b,G)=>({item:b,itemIndex:G}));const g=W.current.word,y=W.current.last,D=u.sameCharsOnly(g,y);let a=m.length,d=Math.max(0,i.findIndex(b=>u.areSame(b,p,n))),c;r.defaultItem&&(c={item:r.defaultItem,itemIndex:-1},a+=1,d+=1),d+=D?1:0,m=u.shuffleData(m,d,c);let I,w,S,l=0;const{textField:P}=r;for(;l<a;){if(I=u.getItemValue(m[l].item,P),w=D&&u.matchText(I,y,fe),S=u.matchText(I,g,fe),w||S){l=m[l].itemIndex;break}l++}if(l!==a){const b=t.current.initState();b.syntheticEvent=e,J(l,b),K(b),q.current=void 0}},Ct=e=>{clearTimeout(We.current),r.filterable||(We.current=window.setTimeout(()=>W.current.word="",it),xt(e))},Lt=e=>{re.current||t.current.handleFocus(e)},kt=e=>{if(re.current||!f.focused)return;const n=r.opened!==void 0?r.opened:f.opened,i=t.current.initState();i.syntheticEvent=e,i.data.focused=!1,i.events.push({type:"onBlur"}),n&&Ie(),n&&!Ke&&t.current.togglePopup(i),K(i)},Et=e=>{if(r.filterable||e.which===0||e.keyCode===o.Keys.enter)return;let n=String.fromCharCode(e.charCode||e.keyCode);fe&&(n=n.toLowerCase()),n===" "&&e.preventDefault(),W.current={word:W.current.word+n,last:W.current.last+n},Ct(e)},Nt=()=>{const e=t.current.initState();e.data.opened=f.opened,t.current.togglePopup(e),K(e)},He=s.useRef(null),Q=s.useRef(null),xe=s.useRef(),X=s.useRef(null);s.useImperativeHandle(He,()=>({get element(){return Q.current},get index(){return dt()},get name(){return r.name},get validity(){return ye()},get value(){return E()},get focused(){return f.focused},get opened(){return f.opened},focus:ct,props:r,togglePopup:Nt})),s.useImperativeHandle(Y,()=>He.current);const We=s.useRef(null),W=s.useRef({word:"",last:""}),re=s.useRef(!1),q=s.useRef(null),A=s.useRef(!1),Ce=s.useRef(!1),z=s.useRef({}),Le=s.useRef({}),t=s.useRef(new at({props:v,setState:()=>{},state:{},forceUpdate:()=>{},element:null,value:null,handleItemSelect:()=>{}})),_e=s.useRef(0),Z=s.useRef(null),[f,bt]=s.useState({}),[_,Kt]=s.useState(),[,Ue]=s.useReducer(e=>e,!0),Pt=$t.useLocalization(),R=e=>{bt({...f,...e})};s.useEffect(()=>{t.current.updateComponentArgs({props:v,setState:R,state:f,forceUpdate:Ue,element:Q.current,handleItemSelect:J,value:E()})},[R,f,Ue,J,E]),s.useEffect(()=>{var d,c,I,w,S,l,P,b,G,te,le,ce,C;const{dataItemKey:e,virtual:n,groupField:i="",textField:p}=r,m=u.getFilteredData(v),g=z.current.virtual?z.current.virtual.total:0,y=r.opened!==void 0?r.opened:f.opened,D=z.current.opened!==void 0?z.current.opened:Le.current.opened,a=!D&&y;if((d=t==null?void 0:t.current)==null||d.didUpdate(),(c=t==null?void 0:t.current)!=null&&c.getPopupSettings().animate||a&&he(),n&&n.total!==g)(I=t==null?void 0:t.current)==null||I.vs.calcScrollElementHeight(),(w=t==null?void 0:t.current)==null||w.vs.reset();else{const M=E(),de=z.current.value!==void 0?z.current.value:Le.current.value;let B=m.findIndex(j=>u.areSame(j,M,e));i!==""&&M&&p&&(B=(l=(S=t==null?void 0:t.current)==null?void 0:S.getGroupedDataModernMode(m,i))==null?void 0:l.map(j=>j[p]).indexOf(M[p]));const ue=!u.areSame(de,M,e);a&&n?(P=t==null?void 0:t.current)==null||P.scrollToVirtualItem(n,B):a&&!n?(he(),m&&m.length!==0&&((b=t==null?void 0:t.current)==null||b.resetGroupStickyHeader(m[0][i],{setState:R,group:f.group,state:f})),(G=t==null?void 0:t.current)==null||G.scrollToItem(B)):y&&D&&M&&ue&&!A.current?(le=t==null?void 0:t.current)==null||le.scrollToItem(B,(te=t==null?void 0:t.current)==null?void 0:te.vs.enabled):y&&D&&A.current&&(A.current&&n&&n.skip===0?(ce=t==null?void 0:t.current)==null||ce.vs.reset():A.current&&n&&n.skip===n.total-n.pageSize&&((C=t==null?void 0:t.current)==null||C.vs.scrollToEnd()))}A.current=!1,Le.current=f,z.current=r,Oe()}),s.useEffect(()=>{var e,n;return Z.current=o.canUseDOM&&window.ResizeObserver&&new window.ResizeObserver(pt.bind(void 0)),(e=t==null?void 0:t.current)==null||e.didMount(),Oe(),(n=ve())!=null&&n.body&&Z.current&&Z.current.observe(ve().body),()=>{var i;(i=ve())!=null&&i.body&&Z.current&&Z.current.disconnect()}},[]);const Ge=me+"-accessibility-id",ke=me+"-listbox-id",je=me+"-guid",Ft=Pt.toLanguageString(Fe.dropDownListArrowBtnAriaLabel,Fe.messages[Fe.dropDownListArrowBtnAriaLabel]),{style:oe,className:Mt,label:Ee,dir:Tt,virtual:V,adaptive:Zt,dataItemKey:Ot,disabled:ae,loading:Ye,iconClassName:$e,svgIcon:Je,valueRender:Qe}=r,Ne=r.opened!==void 0?r.opened:f.opened,se=E(),be=u.getItemValue(se,r.textField),Xe=!ut()||ye().valid,ie=t.current,qt=ie.vs,ee=N&&N.uDropDownList;qt.enabled=V!==void 0;const U=o.useAdaptiveModeContext(),Ke=!!(_&&U&&_<=U.medium&&v.adaptive);V!==void 0&&(ie.vs.skip=V.skip,ie.vs.total=V.total,ie.vs.pageSize=V.pageSize);const At=u.getFilteredData(v),{focused:zt}=f,Vt=At.findIndex(e=>u.areSame(e,se,Ot)),Ze=s.createElement("span",{id:Ge,className:o.classNames(o.uDropDownList.inputInner({c:ee}))},be&&s.createElement("span",{className:o.classNames(o.uDropDownList.inputText({c:ee}))},be)),Bt=Qe!==void 0?Qe.call(void 0,Ze,se):Ze,Re=s.createElement(s.Fragment,null,s.createElement("span",{ref:mt,className:o.classNames(o.uDropDownList.wrapper({c:ee,size:$,rounded:Te,fillMode:ge,focused:zt,disabled:ae,invalid:!Xe,loading:Ye,required:De()}),Mt),style:Ee?{...oe,width:void 0}:oe,dir:Tt,onMouseDown:Ne?e=>{e.target.nodeName!=="INPUT"&&(ne(t.current.wrapper),e.preventDefault())}:void 0,onFocus:Lt,onBlur:kt,tabIndex:o.getTabIndex(lt,ae),accessKey:r.accessKey,onKeyDown:Ae,onKeyPress:Et,onClick:ae?void 0:Se,role:"combobox","aria-required":De(),"aria-disabled":ae||void 0,"aria-haspopup":"listbox","aria-expanded":Ne||!1,"aria-owns":ke,"aria-activedescendant":Ne?"option-"+je+"-"+(Vt+(V?V.skip:0)):void 0,"aria-label":r.ariaLabel||r.label,"aria-labelledby":r.ariaLabelledBy,"aria-describedby":r.ariaDescribedBy||Ge,"aria-controls":ke,id:r.id,title:r.title},Bt,Ye&&s.createElement(o.IconWrap,{className:o.classNames(o.uDropDownList.loadingIcon({c:ee})),name:"loading"}),s.createElement(ot.Button,{tabIndex:-1,type:"button","aria-label":Ft,size:$,fillMode:ge,iconClass:$e,className:o.classNames(o.uDropDownList.inputButton({c:ee})),rounded:null,themeColor:"base",icon:$e?void 0:"caret-alt-down",svgIcon:Je||nt.caretAltDownIcon,onMouseDown:e=>f.focused&&e.preventDefault()}),ft(se),!Ke&&St()),Ke&&ht());return Ee?s.createElement(Wt.FloatingLabel,{label:Ee,editorValue:be,editorValid:Xe,editorDisabled:r.disabled,style:{width:oe?oe.width:void 0},children:Re}):Re});pe.propTypes={delay:k.number,ignoreCase:k.bool,iconClassName:k.string,svgIcon:o.svgIconPropType,defaultItem:k.any,valueRender:k.func,valueMap:k.func,validationMessage:k.string,required:k.bool,id:k.string,ariaLabelledBy:k.string,ariaDescribedBy:k.string,ariaLabel:k.string,leftRightKeysNavigation:k.bool,title:k.string,groupField:k.string,list:k.any,skipDisabledItems:k.bool};const F={delay:500,tabIndex:0,ignoreCase:!0,...at.defaultProps,required:!1,size:"medium",rounded:"medium",fillMode:"solid",groupMode:"modern"};pe.displayName="KendoReactDropDownList";const st=o.createPropsContext();pe.displayName="KendoReactDropDownList";exports.DropDownList=pe;exports.DropDownListPropsContext=st;exports.dropDownListDefaultProps=F;
